package com.platform.yijia.controller;

import com.alibaba.fastjson.JSONObject;
import com.google.gson.Gson;
import com.platform.yijia.pojo.StationInfo;
import com.platform.yijia.pojo.StationInfoExample;
import com.platform.yijia.service.StationService;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

@Controller
@RequestMapping("/api")
public class StationController {
    @Resource
    private StationService stationService;
    /**
     * 获取油站列表
     */
    @RequestMapping(value = "/getStationInfoList", method = RequestMethod.GET)
    @ResponseBody
    public void getStationInfoList(HttpServletRequest request, HttpServletResponse response){
        JSONObject req = new JSONObject();
        //获取当前用户坐标
        String zuobiao=request.getParameter("zuobiao");
        Gson gson =new Gson();
        if(zuobiao!=null){
            if(zuobiao==""){
                StationInfo stationInfo=new StationInfo();

                //调用接口 根据坐标筛选距离最近的加油站
                List<StationInfo> stationInfoList = stationService.stationInfoList(stationInfo);
                req.put("code","000");
                req.put("msg","请求成功");
                req.put("data","");
            }else{
                req.put("code","002");
                req.put("msg","获取坐标失败");
            }
        }else{
            req.put("code","001");
            req.put("msg","坐标未传参数");
        }
        try {
            response.setContentType("application/json; charset=UTF-8");
            response.setCharacterEncoding("UTF-8");
            response.getWriter().print(req);
            response.getWriter().flush();
            response.getWriter().close();
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
