package com.platform.yijia.service.impl;
import com.platform.yijia.dao.StationInfoMapper;
import com.platform.yijia.pojo.StationInfo;
import com.platform.yijia.pojo.StationInfoExample;
import com.platform.yijia.service.StationService;
import com.platform.yijia.utils.MapHelper;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

@Service("stationService")
public class StationServiceImpl implements StationService {

    @Resource
    private StationInfoMapper stationInfoMapper;
    @Override
    public List<StationInfo> stationInfoList(StationInfo stationInfo) {
        //根据传过来的坐标查询数据
        List<StationInfo> distanceAndResidueSeat = new ArrayList<>();
        StationInfoExample example=new StationInfoExample();
        // 数据库查询门店数据
        List<StationInfo> stationInfolist = stationInfoMapper.selectByExample(example);
        // 入参坐标拼接
        String coordinate = stationInfo.getStationLatitude()+","+stationInfo.getStationLongitude();
        if(StringUtils.isNotBlank(stationInfo.getStationLatitude()) && StringUtils.isNotBlank(stationInfo.getStationLongitude())){
            //根据地址坐标计算距离
            List<StationInfo> stationInfos = computeDistance(coordinate, stationInfolist);
            //根据距离排序
            distanceAndResidueSeat = getDistanceAndResidueSeat(stationInfos);
        }
        return distanceAndResidueSeat;
    }
    /**
     * 根据地址坐标计算距离
     * @return
     */
    public List<StationInfo> computeDistance(String coordinate, List<StationInfo> stationInfos){
        List<StationInfo> stationInfoList = new ArrayList<>();
        if(stationInfos!=null && stationInfos.size() > 0){
            for (StationInfo stationInfo : stationInfos) {
                String longitude = stationInfo.getStationLongitude();
                String latitude = stationInfo.getStationLatitude();
                if(StringUtils.isNotBlank(longitude) && StringUtils.isNotBlank(latitude) && StringUtils.isNotBlank(coordinate)){
                    String distanceData = latitude+","+longitude;
                    double distance = MapHelper.GetPointDistance(coordinate, distanceData);
                    Double format = Double.parseDouble(String.format("%.1f", distance));
                    //计算距离
                   // stationInfo.setDistance(format);
                    stationInfoList.add(stationInfo);
                }
            }
        }
        return stationInfoList;
    }

    /**
     * 根据距离排序
     * @return
     */
    public static List<StationInfo> getDistanceAndResidueSeat(List<StationInfo> list) {
        StationInfo stationInfo = null;
        boolean exchange = false;
        for (int i = 0; i < list.size(); i++) {
            for (int j = list.size() - 2; j >= i; j--) {
                //循环根据距离进行排序
//                if (list.get(j + 1).getDistance() < list.get(j).getDistance()) {
//                    tDept = list.get(j + 1);
//                    list.set(j + 1, list.get(j));
//                    list.set(j, tDept);
//                    exchange = true;
//                }
            }
            if (!exchange)
                break;
        }
        return list;
    }
}
